"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MappedExceptionModule = exports.MappedExceptionOptions = void 0;
const common_1 = require("@nestjs/common");
const mapped_exception_class_1 = require("./mapped-exception.class");
class MappedExceptionOptions {
}
exports.MappedExceptionOptions = MappedExceptionOptions;
let MappedExceptionModule = (() => {
    var MappedExceptionModule_1;
    let MappedExceptionModule = MappedExceptionModule_1 = class MappedExceptionModule {
        static forFeature(exception, options) {
            const prefix = options.prefix || process.env.EXCEPTION_ERROR_PREFIX || 'ERR';
            const provider = {
                provide: mapped_exception_class_1.MappedException,
                useValue: new mapped_exception_class_1.MappedException(exception, Object.assign(Object.assign({}, options), { prefix })),
            };
            return {
                providers: [provider],
                exports: [provider],
                module: MappedExceptionModule_1,
            };
        }
        static forRoot(exceptions, options = { prefix: 'ERR' }) {
            const providers = exceptions.map((exception) => {
                const exceptionInstance = new exception();
                return {
                    provide: exception,
                    useValue: new mapped_exception_class_1.MappedException(exception, options),
                };
            });
            return {
                global: true,
                providers: providers,
                exports: providers,
                module: MappedExceptionModule_1,
            };
        }
    };
    MappedExceptionModule = MappedExceptionModule_1 = __decorate([
        common_1.Module({})
    ], MappedExceptionModule);
    return MappedExceptionModule;
})();
exports.MappedExceptionModule = MappedExceptionModule;
//# sourceMappingURL=mapped-exception.module.js.map